#*************************************************************************
#*
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.33 $
#
#   last change: $Author: rt $ $Date: 2006-05-04 09:16:11 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#************************************************************************

PRJ=..$/..$/..

PRJNAME=i18npool
TARGET=localedata
LIBTARGET=NO

# Disable debugging on MSC compilers, due linker bug
.IF "$(COM)"=="MSC"
debug!=
.ENDIF

# --- Settings -----------------------------------------------------

.INCLUDE :  settings.mk

# macro to link with localedata_en library
.IF "$(GUI)" == "WNT"
LINK_LOCALEDATA_EN_LIB=$(LB)$/i$(SHL1TARGET).lib
LINK_LOCALEDATA_ES_LIB=$(LB)$/i$(SHL2TARGET).lib
.ELSE
LINK_LOCALEDATA_EN_LIB=-l$(SHL1TARGET)
LINK_LOCALEDATA_ES_LIB=-l$(SHL2TARGET)
.ENDIF

# --- Files --------------------------------------------------------

# Interim files generated by the saxparser executable, for dependencies
MY_MISC_CXXFILES = \
    $(MISC)$/localedata_af_ZA.cxx  \
    $(MISC)$/localedata_ak_GH.cxx  \
    $(MISC)$/localedata_ar_EG.cxx  \
    $(MISC)$/localedata_ar_LB.cxx  \
    $(MISC)$/localedata_ar_SA.cxx  \
    $(MISC)$/localedata_ar_TN.cxx  \
    $(MISC)$/localedata_az_AZ.cxx  \
    $(MISC)$/localedata_be_BY.cxx  \
    $(MISC)$/localedata_bg_BG.cxx  \
    $(MISC)$/localedata_bn_IN.cxx  \
    $(MISC)$/localedata_bn_BD.cxx  \
    $(MISC)$/localedata_br_FR.cxx  \
    $(MISC)$/localedata_bs_BA.cxx  \
    $(MISC)$/localedata_ca_ES.cxx  \
    $(MISC)$/localedata_cs_CZ.cxx  \
    $(MISC)$/localedata_cy_GB.cxx  \
    $(MISC)$/localedata_da_DK.cxx  \
    $(MISC)$/localedata_de_AT.cxx  \
    $(MISC)$/localedata_de_CH.cxx  \
    $(MISC)$/localedata_de_DE.cxx  \
    $(MISC)$/localedata_de_LI.cxx  \
    $(MISC)$/localedata_de_LU.cxx  \
    $(MISC)$/localedata_dz_BT.cxx  \
    $(MISC)$/localedata_el_GR.cxx  \
    $(MISC)$/localedata_en_AU.cxx  \
    $(MISC)$/localedata_en_BZ.cxx  \
    $(MISC)$/localedata_en_CA.cxx  \
    $(MISC)$/localedata_en_GB.cxx  \
    $(MISC)$/localedata_en_IE.cxx  \
    $(MISC)$/localedata_en_IN.cxx  \
    $(MISC)$/localedata_en_JM.cxx  \
    $(MISC)$/localedata_en_NZ.cxx  \
    $(MISC)$/localedata_en_PH.cxx  \
    $(MISC)$/localedata_en_TT.cxx  \
    $(MISC)$/localedata_en_US.cxx  \
    $(MISC)$/localedata_en_ZA.cxx  \
    $(MISC)$/localedata_en_ZW.cxx  \
    $(MISC)$/localedata_eo.cxx     \
    $(MISC)$/localedata_es_AR.cxx  \
    $(MISC)$/localedata_es_BO.cxx  \
    $(MISC)$/localedata_es_CL.cxx  \
    $(MISC)$/localedata_es_CO.cxx  \
    $(MISC)$/localedata_es_CR.cxx  \
    $(MISC)$/localedata_es_DO.cxx  \
    $(MISC)$/localedata_es_EC.cxx  \
    $(MISC)$/localedata_es_ES.cxx  \
    $(MISC)$/localedata_es_GT.cxx  \
    $(MISC)$/localedata_es_HN.cxx  \
    $(MISC)$/localedata_es_MX.cxx  \
    $(MISC)$/localedata_es_NI.cxx  \
    $(MISC)$/localedata_es_PA.cxx  \
    $(MISC)$/localedata_es_PE.cxx  \
    $(MISC)$/localedata_es_PR.cxx  \
    $(MISC)$/localedata_es_PY.cxx  \
    $(MISC)$/localedata_es_SV.cxx  \
    $(MISC)$/localedata_es_UY.cxx  \
    $(MISC)$/localedata_es_VE.cxx  \
    $(MISC)$/localedata_et_EE.cxx  \
    $(MISC)$/localedata_eu.cxx     \
    $(MISC)$/localedata_fi_FI.cxx  \
    $(MISC)$/localedata_fo_FO.cxx  \
    $(MISC)$/localedata_fr_BE.cxx  \
    $(MISC)$/localedata_fr_CA.cxx  \
    $(MISC)$/localedata_fr_CH.cxx  \
    $(MISC)$/localedata_fr_FR.cxx  \
    $(MISC)$/localedata_fr_LU.cxx  \
    $(MISC)$/localedata_fr_MC.cxx  \
    $(MISC)$/localedata_ga_IE.cxx  \
    $(MISC)$/localedata_gl_ES.cxx  \
    $(MISC)$/localedata_gu_IN.cxx  \
    $(MISC)$/localedata_he_IL.cxx  \
    $(MISC)$/localedata_hi_IN.cxx  \
    $(MISC)$/localedata_hr_HR.cxx  \
    $(MISC)$/localedata_hu_HU.cxx  \
    $(MISC)$/localedata_ia.cxx     \
    $(MISC)$/localedata_id_ID.cxx  \
    $(MISC)$/localedata_is_IS.cxx  \
    $(MISC)$/localedata_it_CH.cxx  \
    $(MISC)$/localedata_it_IT.cxx  \
    $(MISC)$/localedata_ja_JP.cxx  \
    $(MISC)$/localedata_ka_GE.cxx  \
    $(MISC)$/localedata_kl_GL.cxx  \
    $(MISC)$/localedata_km_KH.cxx  \
    $(MISC)$/localedata_kn_IN.cxx  \
    $(MISC)$/localedata_ko_KR.cxx  \
    $(MISC)$/localedata_ku_TR.cxx  \
    $(MISC)$/localedata_la_VA.cxx  \
    $(MISC)$/localedata_lo_LA.cxx  \
    $(MISC)$/localedata_lt_LT.cxx  \
    $(MISC)$/localedata_lv_LV.cxx  \
    $(MISC)$/localedata_mk_MK.cxx  \
    $(MISC)$/localedata_ml_IN.cxx  \
    $(MISC)$/localedata_mn_MN.cxx  \
    $(MISC)$/localedata_mr_IN.cxx  \
    $(MISC)$/localedata_ms_MY.cxx  \
    $(MISC)$/localedata_nb_NO.cxx  \
    $(MISC)$/localedata_ne_NP.cxx  \
    $(MISC)$/localedata_nl_BE.cxx  \
    $(MISC)$/localedata_nl_NL.cxx  \
    $(MISC)$/localedata_nn_NO.cxx  \
    $(MISC)$/localedata_no_NO.cxx  \
    $(MISC)$/localedata_nr_ZA.cxx  \
    $(MISC)$/localedata_nso_ZA.cxx \
    $(MISC)$/localedata_or_IN.cxx  \
    $(MISC)$/localedata_pa_IN.cxx  \
    $(MISC)$/localedata_pl_PL.cxx  \
    $(MISC)$/localedata_pt_BR.cxx  \
    $(MISC)$/localedata_pt_PT.cxx  \
    $(MISC)$/localedata_ro_RO.cxx  \
    $(MISC)$/localedata_ru_RU.cxx  \
    $(MISC)$/localedata_rw_RW.cxx  \
    $(MISC)$/localedata_sh_YU.cxx  \
    $(MISC)$/localedata_sk_SK.cxx  \
    $(MISC)$/localedata_sl_SI.cxx  \
    $(MISC)$/localedata_sr_YU.cxx  \
    $(MISC)$/localedata_ss_ZA.cxx  \
    $(MISC)$/localedata_st_ZA.cxx  \
    $(MISC)$/localedata_sv_FI.cxx  \
    $(MISC)$/localedata_sv_SE.cxx  \
    $(MISC)$/localedata_sw_TZ.cxx  \
    $(MISC)$/localedata_ta_IN.cxx  \
    $(MISC)$/localedata_te_IN.cxx  \
    $(MISC)$/localedata_th_TH.cxx  \
    $(MISC)$/localedata_tn_ZA.cxx  \
    $(MISC)$/localedata_tr_TR.cxx  \
    $(MISC)$/localedata_ts_ZA.cxx  \
    $(MISC)$/localedata_uk_UA.cxx  \
    $(MISC)$/localedata_ve_ZA.cxx  \
    $(MISC)$/localedata_vi_VN.cxx  \
    $(MISC)$/localedata_xh_ZA.cxx  \
    $(MISC)$/localedata_zh_CN.cxx  \
    $(MISC)$/localedata_zh_HK.cxx  \
    $(MISC)$/localedata_zh_MO.cxx  \
    $(MISC)$/localedata_zh_SG.cxx  \
    $(MISC)$/localedata_zh_TW.cxx  \
    $(MISC)$/localedata_zu_ZA.cxx


# English Locales
SHL1TARGET=localedata_en
SHL1IMPLIB=i$(SHL1TARGET)

SHL1VERSIONMAP=$(SHL1TARGET).map
SHL1DEF=$(MISC)$/$(SHL1TARGET).def
DEF1NAME=$(SHL1TARGET)

SHL1OBJS= \
    $(SLO)$/localedata_en_AU.obj \
    $(SLO)$/localedata_en_BZ.obj \
    $(SLO)$/localedata_en_CA.obj \
    $(SLO)$/localedata_en_GB.obj \
    $(SLO)$/localedata_en_IE.obj \
    $(SLO)$/localedata_en_JM.obj \
    $(SLO)$/localedata_en_NZ.obj \
    $(SLO)$/localedata_en_PH.obj \
    $(SLO)$/localedata_en_TT.obj \
    $(SLO)$/localedata_en_US.obj \
    $(SLO)$/localedata_en_ZA.obj \
    $(SLO)$/localedata_en_ZW.obj

LIB1TARGET=	$(SLB)$/$(SHL1TARGET).lib
LIB1OBJFILES=$(SHL1OBJS)

# Spanish Locales
SHL2TARGET=localedata_es
SHL2IMPLIB=i$(SHL2TARGET)

SHL2VERSIONMAP=$(SHL2TARGET).map
SHL2DEF=$(MISC)$/$(SHL2TARGET).def
DEF2NAME=$(SHL2TARGET)

SHL2STDLIBS=	$(LINK_LOCALEDATA_EN_LIB)
SHL2DEPN=$(SHL1TARGETN)
SHL2OBJS= \
    $(SLO)$/localedata_es_AR.obj \
    $(SLO)$/localedata_es_BO.obj \
    $(SLO)$/localedata_es_CL.obj \
    $(SLO)$/localedata_es_CO.obj \
    $(SLO)$/localedata_es_CR.obj \
    $(SLO)$/localedata_es_DO.obj \
    $(SLO)$/localedata_es_EC.obj \
    $(SLO)$/localedata_es_ES.obj \
    $(SLO)$/localedata_es_GT.obj \
    $(SLO)$/localedata_es_HN.obj \
    $(SLO)$/localedata_es_MX.obj \
    $(SLO)$/localedata_es_NI.obj \
    $(SLO)$/localedata_es_PA.obj \
    $(SLO)$/localedata_es_PE.obj \
    $(SLO)$/localedata_es_PR.obj \
    $(SLO)$/localedata_es_PY.obj \
    $(SLO)$/localedata_es_SV.obj \
    $(SLO)$/localedata_es_UY.obj \
    $(SLO)$/localedata_es_VE.obj

LIB2TARGET=	$(SLB)$/$(SHL2TARGET).lib
LIB2OBJFILES=$(SHL2OBJS)

# European Locales
SHL3TARGET=localedata_euro
SHL3IMPLIB=i$(SHL3TARGET)

SHL3VERSIONMAP=$(SHL3TARGET).map
SHL3DEF=$(MISC)$/$(SHL3TARGET).def
DEF3NAME=$(SHL3TARGET)

SHL3STDLIBS=	$(LINK_LOCALEDATA_EN_LIB) $(LINK_LOCALEDATA_ES_LIB)
SHL3DEPN=$(SHL1TARGETN) $(SHL2TARGETN)
SHL3OBJS=	\
    $(SLO)$/localedata_be_BY.obj	\
    $(SLO)$/localedata_bg_BG.obj	\
    $(SLO)$/localedata_br_FR.obj	\
    $(SLO)$/localedata_bs_BA.obj	\
    $(SLO)$/localedata_ca_ES.obj	\
    $(SLO)$/localedata_cs_CZ.obj	\
    $(SLO)$/localedata_cy_GB.obj	\
    $(SLO)$/localedata_da_DK.obj	\
    $(SLO)$/localedata_de_AT.obj	\
    $(SLO)$/localedata_de_CH.obj	\
    $(SLO)$/localedata_de_DE.obj	\
    $(SLO)$/localedata_de_LI.obj	\
    $(SLO)$/localedata_de_LU.obj	\
    $(SLO)$/localedata_el_GR.obj	\
    $(SLO)$/localedata_et_EE.obj	\
    $(SLO)$/localedata_eu.obj		\
    $(SLO)$/localedata_fi_FI.obj	\
    $(SLO)$/localedata_fo_FO.obj	\
    $(SLO)$/localedata_fr_BE.obj	\
    $(SLO)$/localedata_fr_CA.obj	\
    $(SLO)$/localedata_fr_CH.obj	\
    $(SLO)$/localedata_fr_FR.obj	\
    $(SLO)$/localedata_fr_LU.obj	\
    $(SLO)$/localedata_fr_MC.obj	\
    $(SLO)$/localedata_ga_IE.obj	\
    $(SLO)$/localedata_gl_ES.obj	\
    $(SLO)$/localedata_hr_HR.obj	\
    $(SLO)$/localedata_is_IS.obj	\
    $(SLO)$/localedata_it_CH.obj	\
    $(SLO)$/localedata_it_IT.obj	\
    $(SLO)$/localedata_ka_GE.obj	\
    $(SLO)$/localedata_kl_GL.obj	\
    $(SLO)$/localedata_la_VA.obj	\
    $(SLO)$/localedata_lt_LT.obj	\
    $(SLO)$/localedata_lv_LV.obj	\
    $(SLO)$/localedata_mk_MK.obj	\
    $(SLO)$/localedata_nb_NO.obj	\
    $(SLO)$/localedata_nl_BE.obj	\
    $(SLO)$/localedata_nl_NL.obj	\
    $(SLO)$/localedata_nn_NO.obj	\
    $(SLO)$/localedata_no_NO.obj	\
    $(SLO)$/localedata_pl_PL.obj	\
    $(SLO)$/localedata_pt_BR.obj	\
    $(SLO)$/localedata_pt_PT.obj	\
    $(SLO)$/localedata_ru_RU.obj	\
    $(SLO)$/localedata_ro_RO.obj	\
    $(SLO)$/localedata_sh_YU.obj	\
    $(SLO)$/localedata_sk_SK.obj	\
    $(SLO)$/localedata_sl_SI.obj	\
    $(SLO)$/localedata_sr_YU.obj	\
    $(SLO)$/localedata_sv_FI.obj	\
    $(SLO)$/localedata_sv_SE.obj	\
    $(SLO)$/localedata_tr_TR.obj	\
    $(SLO)$/localedata_uk_UA.obj

LIB3TARGET=	$(SLB)$/$(SHL3TARGET).lib
LIB3OBJFILES=$(SHL3OBJS)

# Other Locales
SHL4TARGET=localedata_others
SHL4IMPLIB=i$(SHL4TARGET)

SHL4VERSIONMAP=$(SHL4TARGET).map
SHL4DEF=$(MISC)$/$(SHL4TARGET).def
DEF4NAME=$(SHL4TARGET)

SHL4STDLIBS=	$(LINK_LOCALEDATA_EN_LIB)
SHL4DEPN=$(SHL1TARGETN)
SHL4OBJS= \
    $(SLO)$/localedata_af_ZA.obj \
    $(SLO)$/localedata_ak_GH.obj \
    $(SLO)$/localedata_ar_EG.obj \
    $(SLO)$/localedata_ar_LB.obj \
    $(SLO)$/localedata_ar_SA.obj \
    $(SLO)$/localedata_ar_TN.obj \
    $(SLO)$/localedata_az_AZ.obj \
    $(SLO)$/localedata_bn_IN.obj \
    $(SLO)$/localedata_bn_BD.obj \
     $(SLO)$/localedata_dz_BT.obj \
    $(SLO)$/localedata_en_IN.obj \
    $(SLO)$/localedata_eo.obj    \
    $(SLO)$/localedata_gu_IN.obj \
    $(SLO)$/localedata_he_IL.obj \
    $(SLO)$/localedata_hi_IN.obj \
    $(SLO)$/localedata_hu_HU.obj \
    $(SLO)$/localedata_ia.obj    \
    $(SLO)$/localedata_id_ID.obj \
    $(SLO)$/localedata_ja_JP.obj \
    $(SLO)$/localedata_km_KH.obj \
    $(SLO)$/localedata_kn_IN.obj \
    $(SLO)$/localedata_ko_KR.obj \
    $(SLO)$/localedata_ku_TR.obj \
    $(SLO)$/localedata_lo_LA.obj \
    $(SLO)$/localedata_ml_IN.obj \
    $(SLO)$/localedata_mn_MN.obj \
    $(SLO)$/localedata_mr_IN.obj \
    $(SLO)$/localedata_ms_MY.obj \
    $(SLO)$/localedata_ne_NP.obj \
    $(SLO)$/localedata_nr_ZA.obj \
    $(SLO)$/localedata_nso_ZA.obj \
    $(SLO)$/localedata_or_IN.obj \
    $(SLO)$/localedata_pa_IN.obj \
    $(SLO)$/localedata_rw_RW.obj \
    $(SLO)$/localedata_ss_ZA.obj \
    $(SLO)$/localedata_st_ZA.obj \
    $(SLO)$/localedata_sw_TZ.obj \
    $(SLO)$/localedata_ta_IN.obj \
    $(SLO)$/localedata_te_IN.obj \
    $(SLO)$/localedata_th_TH.obj \
    $(SLO)$/localedata_tn_ZA.obj \
    $(SLO)$/localedata_ts_ZA.obj \
    $(SLO)$/localedata_ve_ZA.obj \
    $(SLO)$/localedata_vi_VN.obj \
    $(SLO)$/localedata_xh_ZA.obj \
    $(SLO)$/localedata_zh_CN.obj \
    $(SLO)$/localedata_zh_HK.obj \
    $(SLO)$/localedata_zh_MO.obj \
    $(SLO)$/localedata_zh_SG.obj \
    $(SLO)$/localedata_zh_TW.obj \
    $(SLO)$/localedata_zu_ZA.obj

LIB4TARGET=	$(SLB)$/$(SHL4TARGET).lib
LIB4OBJFILES=$(SHL4OBJS)

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

$(MY_MISC_CXXFILES) : $(BIN)$/saxparser$(EXECPOST)

$(MISC)$/localedata_%.cxx : %.xml
    +$(WRAPCMD) $(BIN)$/saxparser $* $< $@ $(BIN)$/$(@:b).rdb $(SOLARBINDIR)$/types.rdb
    +$(RM) $(BIN)$/$(@:b).rdb

