/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: implncvt.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005-09-09 12:02:18 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SV_LINECONV_HXX
#define _SV_LINECONV_HXX

#ifndef _TL_POLY_HXX
#include <tools/poly.hxx>
#endif
#ifndef _SV_LINEINFO_HXX
#include <lineinfo.hxx>
#endif

// --------------------
// - ImplLineConverter
// --------------------

struct ImplFloatPoint;

class ImplLineConverter
{
    BOOL            mbClosed;
    BOOL            mbRefPoint;
    INT32           mnRefDistance;

    double          mfWidthHalf;
    LineInfo        maLineInfo;

    double          mfDashDotLenght;
    double          mfDistanceLenght;

    UINT32          mnDashCount;
    UINT32          mnDotCount;

    Polygon         maPolygon;
    UINT32          mnFloat0Points;
    ImplFloatPoint* mpFloat0;
    UINT32          mnFloat1Points;
    ImplFloatPoint* mpFloat1;

    UINT32          mnLinesAvailable;
    UINT32          mnLines;

    ImplFloatPoint* mpFloatPoint;

    public:

                    ImplLineConverter( const Polygon& rPoly, const LineInfo& rLineInfo, const Point* pRefPoint );
                    ~ImplLineConverter();

    const Polygon*  ImplGetFirst();
    const Polygon*  ImplGetNext();
};

#endif
